#
# Author:: Ranjib Dey (<ranjib@pagerduty.com>)
# Copyright:: Copyright (c) 2015 PagerDuty, Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

module Blender
  module SerfDSL
    def serf_task(name, &block)
      task = build_task(name, :serf)
      task.instance_eval(&block) if block_given?
      append_task(:serf, task)
    end
    def serf_async_task(name, &block)
      task = build_task(name, :serf_async)
      task.instance_eval(&block) if block_given?
      append_task(:serf_async, task)
    end
  end
end
